<template>
    <div>
        <q-dialog v-model="showDatePicker">
            <q-card style="min-width: 350px">
                <q-card-section>
                    <div class="text-h6">{{ $t("schedule_session.section_2.time_modal_date") }}</div>
                </q-card-section>

                <q-card-section class="q-pt-none" style="text-align:center">
                    <q-date v-model="manualDate" />
                </q-card-section>

                <q-card-actions align="right" class="text-primary">
                    <q-btn flat :label='$t("cancel")' v-close-popup />
                    <q-btn flat :label='$t("next")' v-close-popup @click="showTimePicker = true" />
                </q-card-actions>
            </q-card>
        </q-dialog>

        <q-dialog v-model="showTimePicker">
            <q-card style="min-width: 350px">
                <q-card-section>
                    <div class="text-h6">{{ $t("schedule_session.section_2.time_modal_time") }}</div>
                    <p>{{ $t("schedule_session.section_2.time_modal_time_help") }}</p>
                </q-card-section>

                <q-card-section class="q-pt-none" style="text-align:center">
                    <q-time v-model="manualTime" format24h :minute-options="minuteOptions" />
                </q-card-section>

                <q-card-actions align="right" class="text-primary">
                    <q-btn flat :label='$t("back")' v-close-popup @click="showDatePicker = true" />
                    <q-btn flat :label='$t("confirm")' v-close-popup @click="manuallyAssignTime()" />
                </q-card-actions>
            </q-card>
        </q-dialog>

        <q-dialog v-model="showErrorAlert">
            <q-card style="min-width: 350px">
                <q-card-section>
                    <div class="text-h6">{{ $t("schedule_session.section_2.error_title") }}</div>
                    <p>{{ alertMessageCurrent }}</p>
                </q-card-section>
                <q-card-actions align="right" class="text-primary">
                    <q-btn flat :label='$t("ok")' v-close-popup />
                </q-card-actions>
            </q-card>
        </q-dialog>

        <div v-if="proposedStartTime" class="booking-text">

            <i18n path="schedule_session.section_2.booking_text_time">
                <template v-slot:datetime>
                    <q-btn @click='showDateTimePopups()' class='booking-btn' no-caps :label="startTimeString" />
                </template>
                <template v-slot:length>
                    <q-select outlined v-model="proposedLengthMins" :options="lengthOptions" class="booking-picker"
                        @input="lengthChanged" />
                </template>
            </i18n>
            <br />
            <i18n path="schedule_session.section_2.booking_text_capacity">
                <template v-slot:trunk>
                    <q-select outlined v-model="proposedTrunk" :options="trunkOptions" class="booking-picker"
                        @input="trunkChanged" />
                </template>
                <template v-slot:capacity>
                    <q-select outlined v-model="proposedCapacity" :options="capacityOptions" class="booking-picker"
                        @input="numSlotChanged" />
                </template>
            </i18n>
            <div v-if="costMessage" class="costMessage">
                {{ costMessage }}
            </div>
            <div class="trunkWarning">
                {{ trunkWarning }}
            </div>

        </div>

        <div style="height: 1rem" />

        <vue-cal style="height: 500px; margin-bottom: 30px;" ref="vuecalref" :hideViewSelector="true"
            :timeCellHeight="timeCellHeight" :activeView="calView" :disableViews="['years', 'year', 'month', 'months']"
            :watchRealTime="true" :showTimeInCells="true" :events="calEvents"
            :editable-events="{ title: false, drag: true, resize: true, delete: false, create: false }"
            :dragToCreateEvent="false" :snapToTime="slotLength" small @event-mouse-enter="inEvent = true"
            @event-mouse-leave="inEvent = false" @event-change="onEventChange($event)" @cell-click="onCellClick($event)"
            :selected-date="editingEvent ? editingEvent.start : new Date()" :min-date="new Date()" />
    </div>
</template>

<script>

import VueCal from 'vue-cal'
import 'vue-cal/dist/vuecal.css'
import moment from 'moment'
import { countriesFromCode, parseNumber } from "../utils/phone";

export default {
    props: {
        existingStartTime: {
            required: true
        },
        existingLengthMins: {
            required: true
        },
        existingCapacity: {
            required: true
        },
        existingEvents: {
            required: true
        },
        editingEventId: {
            required: false
        },
        trunks: {
            required: true
        },
        chosenTrunk: {
            required: true
        },
        updateEvent: {
            required: true,
            type: Function
        }
    },
    data()
    {
        return {
            calWidth: null,
            timeCellHeight: 80,
            inEvent: false,
            capacityOptions: [5, 10, 15, 20, 25, 30, 35, 40, 45, 50],
            proposedStartTime: this.existingStartTime,
            proposedLengthMins: this.existingLengthMins,
            proposedLengthMinsOld: this.existingLengthMins,
            proposedCapacity: this.existingCapacity,
            proposedCapacityOld: this.existingCapacity,
            proposedTrunk: null,
            showDatePicker: false,
            showTimePicker: false,
            showErrorAlert: false,
            manualDate: null,
            manualTime: null,
            alertMessageCurrent: null,
            slotLength: 15,
            maxLength: 120
        }
    },
    mounted()
    {
        if (this.chosenTrunk && this.trunkOptions)
        {
            this.proposedTrunk = this.trunkOptions.find(tr => tr.caller_number === this.chosenTrunk.caller_number)
        }
        else if (!this.proposedTrunk && this.trunkOptions) this.proposedTrunk = this.trunkOptions[0];

        if (!this.proposedStartTime) this.getFirstAvailableSlot();

        this.calWidth = this.$refs.vuecalref['$el'].clientWidth;

        this.scrollToCurrentTime();

        this.$nextTick(() =>
        {
            window.addEventListener('resize', this.onResize);
        })
    },
    beforeDestroy()
    {
        window.removeEventListener('resize', this.onResize);
    },
    computed: {
        minuteOptions()
        {
            let slotsPerHour = 60 / this.slotLength;
            let toRet = [];
            for (let i = 0; i < slotsPerHour; i++)
            {
                toRet.push(i * this.slotLength);
            }
            return toRet;
        },
        lengthOptions()
        {
            let toRet = [];
            let running = this.slotLength;

            while (running <= this.maxLength)
            {
                toRet.push(running);
                running += this.slotLength;
            }
            return toRet;
        },
        trunkOptions()
        {
            let toRet = [];

            for (const trunkId in this.trunks)
            {
                let numData = parseNumber(this.trunks[trunkId].caller_number);
                toRet.push({
                    ...this.trunks[trunkId],
                    ...{
                        label: `${this.trunks[trunkId].caller_number} (${this.trunks[trunkId].handle_all_countries ?
                            this.$t("schedule_session.section_2.booking_trunk_international") :
                            numData.country})`
                    }
                });
            }

            return toRet;
        },
        costMessage()
        {
            if (this.proposedTrunk && !this.proposedTrunk.handle_all_countries)
            {
                let codes = Object.keys(this.proposedTrunk.codes_cost_per_min);
                let sameCost = true;
                let cost = this.proposedTrunk.codes_cost_per_min[codes[0]];
                let lowest = cost;
                let highest = cost;

                // check if there are multiple supported dial codes, with different prices
                // if there are, we want to show a cost range - otherwise, a single value
                if (codes.length > 1)
                {
                    for (let i = 1; i < codes.length; i++)
                    {
                        let thisCost = this.proposedTrunk.codes_cost_per_min[codes[i]];
                        if (thisCost != cost) sameCost = false;
                        if (thisCost < lowest) lowest = thisCost;
                        if (thisCost > highest) highest = thisCost;
                    }
                }

                if (sameCost)
                {
                    let total = this.proposedLengthMins * this.proposedCapacity * this.proposedTrunk.codes_cost_per_min[codes[0]];
                    return this.$t("schedule_session.section_2.booking_trunk_cost", [`$${Math.round(total)} USD`])
                }

                let highestTotal = Math.round(this.proposedLengthMins * this.proposedCapacity * highest);
                let lowestTotal = Math.round(this.proposedLengthMins * this.proposedCapacity * lowest);
                return this.$t("schedule_session.section_2.booking_trunk_cost_spread", [lowestTotal, highestTotal])
            }
            return null;
        },
        trunkWarning()
        {
            if (!this.proposedTrunk) return null;

            if (this.proposedTrunk.handle_all_countries)
            {
                return this.$t("schedule_session.section_2.booking_trunk_international_warning");
            }

            let countries = [];
            Object.keys(this.proposedTrunk.codes_cost_per_min).forEach(code =>
            {
                countries = countries.concat(countriesFromCode(code));
            });

            return this.$t("schedule_session.section_2.booking_trunk_warning", [Array.from(new Set(countries)).join(", ")])
        },
        startTimeString()
        {
            return moment(this.proposedStartTime).format('MMM Do, HH:mm');
        },
        bookedUsage()
        {
            if (!this.proposedTrunk) return {};

            let usage = {}
            let defaultCapacity = 25;
            let now = moment();

            for (const evId in this.existingEvents)
            {
                if (evId === this.editingEventId)
                {
                    // we're editing this event, don't render
                    continue;
                }

                let ev = this.existingEvents[evId];

                // don't render events which are in the past 
                // or events on other trunks
                if (moment(ev.ScheduledEnd) < now ||
                    ev.DropCallJoinNumber !== this.proposedTrunk.caller_number)
                {
                    continue;
                }

                let numSlots = ev.LengthMins / this.slotLength;
                let thisSlot = moment(ev.ScheduledStart);

                for (let i = 0; i < numSlots; i++)
                {
                    if (i > 0) thisSlot.add(this.slotLength, 'minutes')
                    let thisTime = thisSlot.format();
                    if (!usage[thisTime]) usage[thisTime] = ev.MaxCapacity ?? defaultCapacity;
                    else usage[thisTime] += ev.MaxCapacity ?? defaultCapacity;
                }
            }

            return usage;
        },
        calView()
        {
            return this.calWidth < 600 ? 'day' : 'week'
        },
        calEvents()
        {
            if (!this.editingEvent) return this.usageAsEvents;

            return [this.editingEvent].concat(this.usageAsEvents);
        },
        editingEvent()
        {
            if (!this.proposedStartTime)
            {
                return null;
            }
            return {
                start: this.proposedStartTime.toString(),
                end: new Date(this.proposedStartTime.getTime() + this.proposedLengthMins * 60000),
                capacity: this.proposedCapacity,
                title: this.editingEventId ? this.$t("schedule_session.section_2.cal_existing") : this.$t("schedule_session.section_2.cal_new"),
                class: 'new flash',
                resizable: true,
                draggable: true
            }
        },
        usageAsEvents()
        {
            let events = [];
            let thisStart = null;
            let lastAssessed = null;
            let thisUsage = 0;
            let maxCapacity = this.capacityOptions[this.capacityOptions.length - 1];
            let scope = this;

            function createEvent(start, end, usage)
            {
                let isFull = usage >= maxCapacity;
                let enoughRemaining = maxCapacity - usage >= scope.proposedCapacity;

                return {
                    start: start,
                    end: end,
                    title: isFull ? scope.$t("schedule_session.section_2.cal_booked_full") :
                        enoughRemaining ? scope.$t("schedule_session.section_2.cal_booked_enough", [maxCapacity - usage])
                            : scope.$t("schedule_session.section_2.cal_booked_not_enough"),
                    class: isFull ? 'full' : enoughRemaining ? 'enough' : 'notenough',
                    resizable: false,
                    draggable: false,
                    deletable: false,
                    titleEditable: false
                }
            }

            // need to sort existing events by start time
            var sorted = [];
            for (const slot in this.bookedUsage)
            {
                sorted[sorted.length] = slot;
            }
            sorted.sort();

            // loop through each slotLength min mark's usage, checking for when capacity changes
            // and creating calendar events when it does
            sorted.forEach(key =>
            {
                if (thisStart === null) 
                {
                    thisStart = key;
                    lastAssessed = key;
                    thisUsage = this.bookedUsage[key];
                    return;
                }
                let lastPlusSlotLength = moment(lastAssessed).add(this.slotLength, 'minutes');

                if (moment(key) > lastPlusSlotLength || this.bookedUsage[key] != thisUsage)
                {
                    // this isn't continuous usage, create event and start a new block
                    events.push(
                        createEvent(
                            moment(thisStart).toDate().toString(),
                            lastPlusSlotLength.toDate().toString(),
                            thisUsage))

                    thisStart = key;
                    lastAssessed = key;
                    thisUsage = this.bookedUsage[key];
                }

                lastAssessed = key;
            });

            // also add the final, unfinished slot
            if (thisStart != null)
            {
                let lastPlusSlotLength = moment(lastAssessed).add(this.slotLength, 'minutes');
                events.push(
                    createEvent(
                        moment(thisStart).toDate().toString(),
                        lastPlusSlotLength.toDate().toString(),
                        thisUsage))
            }
            return events;
        }
    },
    methods: {
        getFirstAvailableSlot()
        {
            let start = moment(this.getRoundedStartTime(new Date(), this.slotLength));
            while (!this.checkIsAvailable(start.toDate(), this.proposedLengthMins))
            {
                start.add(this.slotLength, 'minutes');
            }
            this.proposedStartTime = start.toDate();
            this.updateEvent(this.proposedStartTime, this.proposedLengthMins, this.proposedCapacity, this.proposedTrunk);
        },
        lengthChanged()
        {
            // check if there's enough capacity for requested number of callers
            if (this.checkIsAvailable(this.proposedStartTime, this.proposedLengthMins))
            {
                this.proposedLengthMinsOld = this.proposedLengthMins;
                this.updateEvent(this.proposedStartTime, this.proposedLengthMins, this.proposedCapacity, this.proposedTrunk);
            }
            else
            {
                this.proposedLengthMins = this.proposedLengthMinsOld;
            }
        },
        trunkChanged()
        {
            if (this.checkIsAvailable(this.proposedStartTime, this.proposedLengthMins))
            {
                this.updateEvent(this.proposedStartTime, this.proposedLengthMins, this.proposedCapacity, this.proposedTrunk);
            }
            else
            {
                this.getFirstAvailableSlot();
            }
        },
        numSlotChanged()
        {
            // check if there's enough capacity for requested number of callers
            if (this.checkIsAvailable(this.proposedStartTime, this.proposedLengthMins))
            {
                this.proposedCapacityOld = this.proposedCapacity;
                this.updateEvent(this.proposedStartTime, this.proposedLengthMins, this.proposedCapacity, this.proposedTrunk);
            }
            else
            {
                this.proposedCapacity = this.proposedCapacityOld;
            }
        },
        showDateTimePopups()
        {
            let thisMo = moment(this.proposedStartTime);
            this.manualDate = thisMo.format('YYYY/MM/DD');
            this.manualTime = thisMo.format('HH:mm');
            this.showDatePicker = true;
        },
        manuallyAssignTime()
        {
            let newStart = moment(`${this.manualDate} ${this.manualTime}`, 'YYYY/MM/DD HH:mm').toDate();
            if (this.checkIsAvailable(newStart, this.proposedLengthMins))
            {
                this.proposedStartTime = newStart;
                this.updateEvent(this.proposedStartTime, this.proposedLengthMins, this.proposedCapacity, this.proposedTrunk);
            }
        },
        getRoundedStartTime(date, roundByMins, shouldFloor = true)
        {
            date.setHours(date.getHours());
            if (shouldFloor)
            {
                date.setMinutes(Math.floor(date.getMinutes() / roundByMins) * roundByMins);
            }
            else
            {
                date.setMinutes(Math.ceil(date.getMinutes() / roundByMins) * roundByMins);
            }
            date.setSeconds(0)

            return date;
        },
        checkIsAvailable(passedStartDateTime, lengthMins)
        {
            let start = moment(this.getRoundedStartTime(passedStartDateTime, this.slotLength));
            let end = moment(start).add(lengthMins, 'minutes');

            // reject if this slot is in the past
            if (end < moment())
            {
                this.alertMessageCurrent = this.$t("schedule_session.section_2.error_past");
                this.showErrorAlert = true;
                return false;
            }

            let numSlots = lengthMins / this.slotLength;
            let thisSlot = moment(start);
            let maxCapacity = this.capacityOptions[this.capacityOptions.length - 1];

            for (let i = 0; i < numSlots; i++)
            {
                thisSlot.add(i * this.slotLength, 'minutes')
                let thisTime = thisSlot.format();

                if (this.bookedUsage[thisTime] && this.bookedUsage[thisTime] + this.proposedCapacity > maxCapacity)
                {
                    this.alertMessageCurrent = this.$t("schedule_session.section_2.error_capacity");
                    this.showErrorAlert = true;
                    return false;
                }
            }
            this.showErrorAlert = false;
            return true;
        },
        onCellClick(clickedTime)
        {
            if (this.inEvent || !clickedTime) return;
            let rounded = this.getRoundedStartTime(clickedTime, this.slotLength);
            if (this.checkIsAvailable(rounded, this.proposedLengthMins))
            {
                this.proposedStartTime = rounded;
                this.updateEvent(this.proposedStartTime, this.proposedLengthMins, this.proposedCapacity, this.proposedTrunk);
            }
            else
            {
                this.cancelCalendarChange();
            }
        },
        onEventChange(update)
        {
            let updated = update.event;
            let minsLength = Math.min(Math.round(Math.abs(updated.end - updated.start) / 60000), this.maxLength);
            updated.start = this.getRoundedStartTime(updated.start, this.slotLength, false);
            update.originalEvent.start = this.getRoundedStartTime(new Date(update.originalEvent.start), this.slotLength, false);

            if (this.checkIsAvailable(updated.start, minsLength))
            {
                this.proposedStartTime = updated.start;
                this.proposedLengthMins = minsLength;

                this.updateEvent(this.proposedStartTime, this.proposedLengthMins, this.proposedCapacity, this.proposedTrunk);
            }
            else
            {
                this.cancelCalendarChange();
            }

        },
        cancelCalendarChange()
        {
            // change event details and then change them back to make calendar view undo changes
            let currentStart = this.proposedStartTime;
            this.proposedStartTime = new Date();
            this.proposedStartTime = currentStart;
        },
        onResize()
        {
            this.calWidth = this.$refs.vuecalref['$el'].clientWidth;
        },
        scrollToCurrentTime()
        {
            // this is gross, but the ref doesn't seem to be ready immediately
            setTimeout(() =>
            {
                const calendar = this.$refs.vuecalref['$el'].querySelector('.vuecal__bg')
                // if we're editing an event, scroll to that. Otherwise, scroll to current time
                const scrollToDate = this.editingEventId ? new Date(this.existingEvents[this.editingEventId].ScheduledStart) : new Date();
                const hours = scrollToDate.getHours() + scrollToDate.getMinutes() / 60
                calendar.scrollTo({ top: (Math.max(hours - 1, 0)) * this.timeCellHeight, behavior: 'smooth' })
            }, 400)

        },
    },
    components: {
        VueCal,
    },
};
</script>

<style>
.vuecal__time-column {
    width: 0px;
    visibility: collapse;
}

.vuecal__flex .vuecal__weekdays-headings {
    padding-left: 0;
}

.cell-time-label {
    border-top: 1px solid #5526e4;
}

.vuecal__cell--disabled {
    background: whitesmoke;
    color: white;
}

.cell-time-label:hover {
    background: cornflowerblue;
    cursor: pointer;
}

.vuecal__event {
    padding-top: 8px;
    border-radius: 5px;
    color: #fff;
    border: 1px solid #fff;
}

.vuecal__event.new {
    background-color: #5526e4;
}

.vuecal__event.enough {
    background-color: dodgerblue;
}

.vuecal__event.full {
    background-color: red;
}

.vuecal__event.notenough {
    background-color: purple;
}

.vuecal__event.flash {
    -webkit-animation: fadeinout 2s linear forwards;
    animation: fadeinout 2s linear forwards;
    animation-iteration-count: infinite;
}

.datepicker {
    width: 250px;
}

.booking-text {
    padding: 10px;
    text-align: center;
}

.booking-btn {
    height: 40px;
    font-size: medium;
    margin: 5px;
}

.available {
    text-align: center;
    color: forestgreen;
}

.unavailable {
    text-align: center;
    color: darkred;
}

.booking-picker {
    display: inline-block;
    font-size: medium;
    padding: 2px;
    margin: 5px;
}

.booking-explainer {
    text-align: center;
    margin: 10px;
}

.costMessage {
    margin-top: 10px;
}

.trunkWarning {
    margin: 10px;
    color: red;
    font-size: small;
}

@-webkit-keyframes fadeinout {

    0%,
    100% {
        opacity: 0.5;
    }

    50% {
        opacity: 1;
    }
}

@keyframes fadeinout {

    0%,
    100% {
        opacity: 0.5;
    }

    50% {
        opacity: 1;
    }
}
</style>